(*
    ===========================================================================

    ---------------------------------------------------------------------------
    Gen's LowTech : bZ[WtbNg
    http://www2.biglobe.ne.jp/~sakai/usehook.htm
    http://www2.biglobe.ne.jp/~sakai/bin/list2.txt

    ---------------------------------------------------------------------------
    Using Hooks
    ms-help://MS.PSDK.1033/winui/winui/windowsuserinterface/windowing/hooks/usinghooks.htm

    ---------------------------------------------------------------------------
    2003/11/25  n
    2004/02/05  C(OƂ/)
    2006/01/14  C()
    ===========================================================================
*)


unit HookMain;

interface

uses
    Windows, Messages, MemMappedFile;

//=============================================================================
//  export
//=============================================================================

//  tbNCXg[
function HookInstall(WindowHandle: HWND): Boolean; export; stdcall;

//  tbNACXg[
procedure HookUnInstall(); export; stdcall;

implementation

//=============================================================================
//  ^`
//=============================================================================

//  L̓eɂ\
type
    PShareHookInfo = ^TShareHookInfo;
    TShareHookInfo = packed record
        HostWindow : HWND;     //  ʒmEBhE
        HMouseHook : HHOOK;    //  tbÑnh
    end;

//  tbN֐^
type
    THookProc = function(nCode: Integer; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;

//  LłȂeɂ\
type
    PLocalHookInfo = ^TLocalHookInfo;
    TLocalHookInfo = record
        MouseHooked: Boolean;   //  tbNtO
        MemoryMappedFile: TMemoryMappedFile;
    end;

var
    //  tbN֐̃CXg[Ɋւێ
    LHI: TLocalHookInfo;

//=============================================================================
//  tbN֐
//=============================================================================

//-----------------------------------------------------------------------------
//  MouseProc
function MouseProc(nCode: Integer; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
var
    hFMO: THandle;
    p   : Pointer;
    Shi : PShareHookInfo;
    Mhs : PMouseHookStruct;
begin
    //  MMFgp
    LHI.MemoryMappedFile.Open(hFMO, p);

    try
        //  tbN\̏
        Shi := PShareHookInfo(p);

        //  ǂȃbZ[Wȁ[
        if not (nCode < 0) then
        begin
            case nCode of

            //  }EXANV
            HC_ACTION:
                begin
                    //  }EX\
                    Mhs := PMouseHookStruct(lParam);

                    //  zXgɁAbZ[W̓eƂ̃nhn
                    PostMessage(Shi^.HostWindow, wParam + WM_APP, Mhs^.hwnd, 0);
               end;

            else
                ;
            end;
        end;

        //  ̐l[
        Result := CallNextHookEx(Shi^.HMouseHook, nCode, wParam, lParam);
    finally
        //MMF}bsOAMMFnhN[Y
        LHI.MemoryMappedFile.Close(hFMO, p);
    end;
end;

//=============================================================================
//  CXg[EACXg[
//=============================================================================

//-----------------------------------------------------------------------------
//  tbNCXg[
function    HookInstall(WindowHandle: HWND): Boolean;
var
    hFMO: THandle;
    p: Pointer;
    Shi: PShareHookInfo;
begin
    //  
    FillChar(LHI, SizeOf(LHI), #0);

    //  }bvht@C쐬
    LHI.MemoryMappedFile := TMemoryMappedFile.Create(SizeOf(TShareHookInfo));

    //  쐬
    if (LHI.MemoryMappedFile.Live) then
    begin
        //  MMFgp
        LHI.MemoryMappedFile.Open(hFMO, p);

        try
            //  tbN\̏(邢͎擾)
            Shi := PShareHookInfo(p);

            //  ʒmL^
            Shi^.HostWindow := WindowHandle;

            //  }EXtbN֐̓o^
            Shi^.HMouseHook := SetWindowsHookEx(WH_MOUSE, MouseProc, HInstance, 0);

            //  }EXtbN
            LHI.MouseHooked := (Shi^.HMouseHook > 0);
        finally
            //  MMFgpI
            LHI.MemoryMappedFile.Close(hFMO, p);
        end;

        //  ?
        Result := LHI.MouseHooked;
    end

    //  쐬s
    else
    begin
        Result := False;
    end;
end;

//-----------------------------------------------------------------------------
//  tbNACXg[
procedure HookUnInstall();
var
    hFMO: THandle;
    p: Pointer;
    Shi: PShareHookInfo;
begin
    //  MMFgp
    LHI.MemoryMappedFile.Open(hFMO, p);

    try
        //  tbN\̏
        Shi := PShareHookInfo(p);

        //  }EXtbN
        if LHI.MouseHooked then UnhookWindowsHookEx(Shi^.HMouseHook);
    finally
        //  MMFgpI
        LHI.MemoryMappedFile.Close(hFMO, p);
    end;

    //  }bvht@Cj
    LHI.MemoryMappedFile.Free();
end;

end.

