(*
    ===========================================================================

    LANZX

    ---------------------------------------------------------------------------

    Gen's LowTech : bZ[WtbNg
    http://www2.biglobe.ne.jp/~sakai/usehook.htm
    http://www2.biglobe.ne.jp/~sakai/bin/list2.txt

    ---------------------------------------------------------------------------

    MMF = Memory Mapped File

    2006.01.14  NX

    ===========================================================================
*)

unit MemMappedFile;

interface

uses
    Windows, SysUtils;


type
    TMemoryMappedFile = class
    private
        FName: String;
        FSize: Cardinal;
        FLive: Boolean;
        FHandle: THandle;
    public
        constructor Create(const Size: Cardinal);
        destructor Destroy(); override;
    public
        function Open(var h: THandle; var p: Pointer): Boolean;
        procedure Close(var h: THandle; var p: Pointer);
    public
        property Name: String read FName;
        property Size: Cardinal read FSize;
        property Live: Boolean read FLive;
        property Handle: THandle read FHandle;
    end;

implementation

//-----------------------------------------------------------------------------
//  OBo[ϐɕĂƂ܂ȂB
const
    MMF_NAME = '{F9563069-4385-4FF2-BE7C-AC97B410161F}';

//-----------------------------------------------------------------------------
constructor TMemoryMappedFile.Create(const Size: Cardinal);
begin
    inherited Create();

    FName := MMF_NAME;
    FSize := Size;

    //  w肳ꂽTCYŃt@C}bsOIuWFNgǂݏpɍ쐬
    FHandle := CreateFileMapping($FFFFFFFF, nil, PAGE_READWRITE, 0, FSize, MMF_NAME);

    //  쐬
    FLive := (FHandle <> 0);
end;

//-----------------------------------------------------------------------------
destructor TMemoryMappedFile.Destroy();
begin
    //  t@C}bsOIuWFNgj
    if (FLive) then CloseHandle(FHandle);

    inherited;
end;

//-----------------------------------------------------------------------------
//  LANZX̂߂̏
function TMemoryMappedFile.Open(var h: THandle; var p: Pointer): Boolean;
begin
    //  łɊJĂȂ
    //Close(h, p);

    //MMFJ
    h := OpenFileMapping(FILE_MAP_ALL_ACCESS, False, MMF_NAME);

    //  t
    if (h <> 0) then
    begin
        p := MapViewOfFile(h, FILE_MAP_ALL_ACCESS, 0, 0, 0);
    end;

    //  mF
    Result := (h <> 0) and (p <> nil);
end;

//-----------------------------------------------------------------------------
//  LANZX̂߂̌n
procedure TMemoryMappedFile.Close(var h: THandle; var p: Pointer);
begin
    //  p <> nil Ȃ h <> 0
    if (p <> nil) then
    begin
        //  MMF̃r[
        UnmapViewOfFile(p);

        //  MMF̃nh
        CloseHandle(h);
    end;

    //  NA
    p := nil;
    h := 0;
end;

end.

