unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Panel1: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  protected
    procedure WndProc(var Msg: TMessage); override;
    procedure DoTargetHack(const WindowHandle: HWND);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
    SHDocVw_TLB;

//=============================================================================
//  DLL C|[g
//=============================================================================

const
    HOOK_DLL_NAME  = 'hook.dll';

function HookInstall(Wnd: HWND): Boolean; stdcall;external HOOK_DLL_NAME;
procedure HookUnInstall(); stdcall;external HOOK_DLL_NAME;

//=============================================================================
//  [eBeB
//=============================================================================

//-----------------------------------------------------------------------------
//  ^Cgo[̃eLXg
function GetWindowTextStr(WH: HWND): string;
var
    WinText: array[0..1024]of char;
begin
    GetWindowText(WH, WinText, 256);
    Result := WinText;
end;

//-----------------------------------------------------------------------------
//  NX
function GetClassNameStr(WH: HWND): string;
var
    WinClass: array[0..1024]of char;
begin
    GetClassName(WH, WinClass, 256);
    Result := WinClass;
end;


//-----------------------------------------------------------------------------
//  ̃EBhËԂ̐eEBhE
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/VCL06.html#VChap6-3
function GetMostTopLevelWindow(hWindow:HWND):HWND;
var
    hAncestor,hPrev:HWND;
begin
    hPrev := hWindow;
    hAncestor := GetParent(hPrev);
    while hAncestor <> 0 do
    begin
        hPrev := hAncestor;
        hAncestor := GetParent(hPrev)
    end;
    hAncestor := hPrev;
    while hAncestor <> 0 do
    begin
        hPrev := hAncestor;
        hAncestor := GetWindow(hPrev,GW_OWNER)
    end;
    result := hPrev;
end;

//=============================================================================
//  tH[
//=============================================================================

//-----------------------------------------------------------------------------
//  tH[
procedure TForm1.FormCreate(Sender: TObject);
begin
    HookInstall(Handle);
end;

//-----------------------------------------------------------------------------
//  tH[j
procedure TForm1.FormDestroy(Sender: TObject);
begin
    HookUnInstall();
end;

//-----------------------------------------------------------------------------
//  bZ[Wnh
procedure TForm1.WndProc(var Msg: TMessage);
begin
    case Msg.Msg - WM_APP of

        //  }EX̍{^グ
        WM_LBUTTONUP: DoTargetHack(Msg.WParam);

    end;

    //  c͊ۓ
    inherited WndProc(Msg);
end;

//-----------------------------------------------------------------------------
//  }EXNbNp
//  }EX̑ΏۂƂȂGNXv[̎tH_pX\
//-----------------------------------------------------------------------------
//  jQGL
//  http://k2top.jpn.org/k2soft/doc/diary2002-12.html
procedure TForm1.DoTargetHack(const WindowHandle: HWND);
var
    TopHandle: HWND;
    SW: IShellWindows;
    IE: InternetExplorer;
    i: Integer;
begin
    Memo1.Lines.Clear();

    //  GNXv[ւ̃C^[tF[X
    SW := CoShellWindows.Create;

    //  w̃nhEBhÊĂ؂̃nh擾
    TopHandle := GetMostTopLevelWindow(WindowHandle);

    //  nḧv̂
    for i := 0 to SW.Count - 1 do
    begin
        //  ^𖾎Ďo
        IE := SW.Item(I) as InternetExplorer;

        try
            //  nhr
            if (TopHandle = IE.HWND) then
            begin
                Memo1.Lines.Add('^Cg@F' + IE.Name);
                Memo1.Lines.Add('pX@@@F' + IE.FullName);
                Memo1.Lines.Add('ƃpX@F' + IE.Path);
                Memo1.Lines.Add('Xe[^XF' + IE.StatusText);
                Memo1.Lines.Add('tpX@F' + IE.LocationURL);
                Memo1.Lines.Add('́@@@F' + IE.LocationName);
                Memo1.Lines.Add('tpXQF' + GetWindowTextStr(IE.HWND));
                Memo1.Lines.Add('NX@F' + GetClassNameStr(IE.HWND));

                //  1
                Break;
            end;
        except
            //  tH_ƗO
            Caption := '(>_<) }ɕC';
        end;
    end;
end;

end.
